
#include "MoveStrategy.h"
#include "Game.h"
#include <algorithm>

MoveStrategy::MoveStrategy(Game &g) : _game(g) {}

void
MoveStrategy::set_depth(int) {}

MyMove
MoveStrategy::get_move()
{
  Point goal = _game._cached_goal;
  MyMove move;
  move._dollars = 1; // fix this
  list<unsigned> items;

  // drop packages if possible/necessary, and if you didn't just pick up
  for (list<unsigned>::iterator i = _game._me._carrying.begin();
      i != _game._me._carrying.end(); i++) {
    if (_game._packages[*i]._dest == _game._me._position) // found final location of this item
      items.push_back(_game._packages[*i]._id);
    if (find(_game._packages_goal.begin(), _game._packages_goal.end(),
	  _game._packages[*i]._id) == _game._packages_goal.end())
      // this item is not in our goal list
      items.push_back(_game._packages[*i]._id); 
  }
  if (items.size() > 0) {
    move._command = DROP;
    move._items = items;
    return move;
  }

  // pick up packages if necessary
  if (_game._packages_goal.size() > _game._me._carrying.size()) {
    for (list<unsigned>::iterator i = _game._standingOn.begin();
	i != _game._standingOn.end(); i++) {
      if (find(_game._packages_goal.begin(), _game._packages_goal.end(),
	    _game._packages[*i]._id) != _game._packages_goal.end())
	// this item is not in our goal list
	items.push_back(_game._packages[*i]._id); 
    }
    if (items.size() > 0) {
      move._command = PICK;
      move._items = items;
      return move;
    }
  }

  // pick up packages if necessary
  if (goal != _game._me._position) {
    _game._ttime.load_distances(_game._me._position);
    move._command = (COMMAND)_game._ttime.get_direction_for(goal);
    return move;
  }
  cout << "Don't know what the hell is happening...randomly moving" << endl;
  return move;
}

