#ifndef DISTANCES_H
#define DISTANCES_H

#include "Types.h"
class Board;
class Point;

// for absolute distances
class Distances
{
  private:
    Matrix<int> _distances;
    Matrix<char> _directions;

    unsigned _x,_y;
    Point _size;
    Point _origin;
    Board& _board;

  public:
    Distances(Board& size); // makes a square this big
    ~Distances();

    // these three go together
    void load_distances(const Point&); // djykstra's
    int get_distance_to(const Point&);
    int get_direction_for(const Point&);
};

#endif
